import junit.framework.*;

/**
 * The test class NotebookTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class NotebookTest extends TestCase
{
    public static void main (String[] args) {
        junit.textui.TestRunner.run(suite());
    }

    public static Test suite() {
        TestSuite newSuite = new TestSuite();
        newSuite.addTest(new NotebookTest("testShowNote"));
        newSuite.addTest(new NotebookTest("testRemoveNote"));
        newSuite.addTest(new NotebookTest("testModifyNote"));
        newSuite.addTest(new NotebookTest("testSortNotes"));
        return newSuite;
    }
    
    public NotebookTest(String s) {
        super(s);
    }

    /**
     * Default constructor for test class NotebookTest
     */
    public NotebookTest()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }

    public void testShowNote()
    {
        Notebook notebook1 = new Notebook();
        assertEquals(0, notebook1.numberOfNotes());
        assertEquals(false, notebook1.showNote("test string"));
        notebook1.storeNote("test string");
        assertEquals(true, notebook1.showNote("test string"));
        notebook1.storeNote("uno");
        notebook1.storeNote("due");
        notebook1.storeNote("tre");
        assertEquals(true, notebook1.showNote("du"));
        assertEquals(true, notebook1.showNote("t"));
        assertEquals(false, notebook1.showNote("xxx"));
    }

    public void testRemoveNote()
    {
        Notebook notebook1 = new Notebook();
        assertEquals(0, notebook1.numberOfNotes());
        assertEquals(false, notebook1.removeNote("xxx"));
        assertEquals(0, notebook1.numberOfNotes());
        notebook1.storeNote("prima nota");
        notebook1.storeNote("seconda nota");
        notebook1.storeNote("terza nota");
        assertEquals(3, notebook1.numberOfNotes());
        assertEquals(false, notebook1.removeNote("xxx"));
        assertEquals(3, notebook1.numberOfNotes());
        assertEquals(true, notebook1.removeNote("sec"));
        assertEquals(2, notebook1.numberOfNotes());
        assertEquals(true, notebook1.removeNote("pri"));
        assertEquals(1, notebook1.numberOfNotes());
        assertEquals(true, notebook1.removeNote("ter"));
        assertEquals(0, notebook1.numberOfNotes());
    }
    
    public void testModifyNote()
    {
        Notebook notebook1 = new Notebook();
        assertEquals(0, notebook1.numberOfNotes());
        assertEquals(false, notebook1.modifyNote("xxx","yyy"));
        notebook1.storeNote("a");
        notebook1.storeNote("bb");
        notebook1.storeNote("ccc");
        notebook1.storeNote("dddd");
        assertEquals(false, notebook1.modifyNote("xxx","yyy"));
        assertEquals(true, notebook1.modifyNote("cc","eee"));
        assertEquals(true, notebook1.showNote("ee"));
        assertEquals(4, notebook1.numberOfNotes());
    }
    
    // Questo test dipende dal funzionamento del metodo modifyNote.
    public void testSortNotes()
    {
        Notebook notebook1 = new Notebook();
        assertEquals(0, notebook1.numberOfNotes());
        notebook1.storeNote("abc");
        notebook1.storeNote("abcdef");
        notebook1.storeNote("a");
        notebook1.storeNote("abcde");
        notebook1.storeNote("ab");
        notebook1.storeNote("abcd");
        assertEquals(6, notebook1.numberOfNotes());
        notebook1.sortNotes();
        assertEquals(6, notebook1.numberOfNotes());
        assertEquals(true, notebook1.modifyNote("a","1"));
        assertEquals(true, notebook1.modifyNote("ab","22"));
        assertEquals(true, notebook1.modifyNote("abc","333"));
        assertEquals(true, notebook1.modifyNote("abcd","4444"));
        assertEquals(true, notebook1.modifyNote("abcde","55555"));
        assertEquals(true, notebook1.modifyNote("abcdef","666666"));
        assertEquals(6, notebook1.numberOfNotes());
    }
}


